(function( $ ) {
	'use strict';
	
	/**
	 * Admin javascript for the support-chat
	 *
	 * @link       http://www.weedesign.de/weebot.html
	 * @since      1.0.0
	 *
	 * @package    weebot
	 * @subpackage weebot/admin/assets
	 */
	 
	
	/*
	*	run the support chat
	*/
	$( window ).load(function() {
		weebotAdmin.run();
	});
	
	var weebotAdmin = new function() {
	
		/*
		*	runs if files for answers are selected
		*/
		this.formSelectFiles = function() {
			$('.weebot-form select.type').unbind("change");
			$('.weebot-form select.type').bind("change",function() {
				var answer_id = (typeof($(this).data("question-id"))!=typeof(undefined)) ? "_"+$(this).data("question-id") : "";
				var answer_files_id = (typeof($(this).data("question-id"))!=typeof(undefined)) ? "_"+$(this).data("question-id") : "";
				if($(this).find("option:selected").val()==3) {
					$("#answer_files"+answer_files_id).removeClass("hidden");
					$("#answer"+answer_id).addClass("hidden");
				} else {
					if(!$("#answer_files"+answer_files_id).hasClass("hidden")) {
						$("#answer_files"+answer_files_id).addClass("hidden");
						$("#answer"+answer_id).removeClass("hidden");
					}
				}
			});
		}
		
		/*
		*	lookup existing answers
		*/
		this.lookup = function(type,id) {
			var query = $("#weebot-lookup-"+type).val();
			if(query!="") {
				var loader = '<div id="weebot-loader" class="weebot-loader">';
				for(var i=1;i<9;i++) {
					loader+= '<div class="loader" id="weebot-loader-'+i+'"></div>';
				}
				loader+= '</div>';
				$("#weebot-lookup-"+type+"-results").html(loader);
				$.ajax({
					type: "POST",
					url: weebotAJAXadmin.ajaxurl,
					data: {
						action: "weebotAJAXadmin",
						method: "lookup",
						data: {
							type: type,
							query: query,
							id: id
						}
					},
					success: function(data){
						$("#weebot-lookup-"+type+"-results").html(data).addClass("visible");
						var options = {
						  valueNames: [ 'type', 'message' ]
						};
						var list = new List('weebot-lookup-'+type+'-list', options);
						$(".use-existing-answer").bind("click",function() {
							$("#weebot-form-"+$(this).data("form")+" input.existing").val($(this).data("id"));
							$("#weebot-form-"+$(this).data("form")+" #submit").trigger("click");
						});
					}
				});
			} else {
				$("#weebot-lookup-"+type+"-results").html($("#weebot-lookup-"+type+"-submit").data("error")).addClass("visible");
			}
		}
		
		/*
		*	check for new questions
		*/
		this.checkNewQuestions = function() {
			$.ajax({
				type: "POST",
				url: weebotAJAXadmin.ajaxurl,
				data: {
					action: "weebotAJAXadmin",
					method: "check"
				},
				success: function(data){
					var dataArr = data.split('<!weebot!>');
					if($("#weebot_newQuestion_count").length==0) {
						$(document.body).append($('<input />').attr({ id : "weebot_newQuestion_count", type: "hidden", value: dataArr[0] }));
					} else {
						if($("#weebot_newQuestion_count").val()*1<dataArr[0]*1) {
							$("#wp-admin-bar-weebot .count").html(dataArr[0]);
						}
						$("#weebot_newQuestion_count").val(dataArr[0]);
					}
					if(dataArr[1]!="") {
						if($("#weebotChat").length==0) {
							$(document.body).append($("<div />").attr({ id : "weebotChat" }).addClass("nano").append($("<div />").addClass("content nano-content")));
						}
						
						$('#weebotChat .content').append(dataArr[1]);
						
						$("#weebotChat").nanoScroller();
						$("#weebotChat").nanoScroller({ scroll: 'bottom' });
						
						$('#weebotChat .answer.button').unbind("click");
						$('#weebotChat .answer.button').bind("click",function() {
							$("#answer_question_"+$(this).data("question-id")).removeClass("hidden");
							$("#weebotChat").nanoScroller();
						});
						$('#weebotChat .close').unbind("click");
						$('#weebotChat .close').bind("click",function() {
							$(this).parent().remove();
							$("#weebotChat").nanoScroller();
							if($('#weebotChat .close').length==0) {
								$("#weebotChat").remove();
							}
						});
						$('#weebotChat form').unbind("submit");
						$('#weebotChat form').bind("submit",function() {
							var page = ($(this).find("input.page").is(":checked")) ? $(this).find("input.page").val() : 0;
							var form = this;
							$.ajax({
								type: "POST",
								url: weebotAJAXadmin.ajaxurl,
								data: {
									action: "weebotAJAXadmin",
									method: "answer",
									data: {
										user: $(this).find("input.user-id").val(),
										question: $(this).find("input.question-id").val(),
										type: $(this).find("select.type").val(),
										action: $(this).find("input.action").val(),
										subject: $(this).find("input.subject").val(),
										file: $(this).find("select.files").val(),
										page: page
									}
								},
								success: function(data){
									$(form).parent().parent().remove();
									if($("#weebotChat .question").length==0) {
										$("#weebotChat").remove();
									}
									$("#weebotChat").nanoScroller();
								}
							});
							return false;
						});
						weebotAdmin.formSelectFiles();
					}
				}
			});
		}
		
		/*
		*	run the support chat
		*/
		this.run = function() {
			$('.weebot_USER_select').bind("change",function() {
				var select = this;
				$.ajax({
					type: "POST",
					url: weebotAJAXadmin.ajaxurl,
					data: {
						action: "weebotAJAXadmin",
						user: $(this).data("user"),
						type: $(this).find("option:selected").val(),
						method: "user"
					},
					success: function(data){
						$(select).after('<span id="weebotInfo">'+$(select).data("success")+'</span>');
						$("#weebotInfo").animate({opacity:0},3000,function() {
							$(this).remove();
						});
					}
				});
			});
			$("#questionsForm,#eventsForm,#userForm").bind("submit",function() {
				if($("#post-search-input").val()!="") {
					var action = $("#questionsForm,#eventsForm,#userForm").attr("action");
					action = action.split("s=");
					$("#questionsForm,#eventsForm,#userForm").attr("action",action);
				}
			});
			$(".weebot-delete").bind("click",function(e) {
				e.preventDefault();
				var element = (typeof($(this).data("remove"))!=typeof(undefined)) ? "#"+$(this).data("remove") : "#post-"+$(this).data("id");
				$.ajax({
					type: "POST",
					url: weebotAJAXadmin.ajaxurl,
					data: {
						action: "weebotAJAXadmin",
						id: $(this).data("id"),
						table: $(this).data("table"),
						method: "delete"
					},
					success: function(data){
						$(element).animate({opacity:0,height:0},500,function() {
							$(element).remove();
						});
					}
				});
			});
			
			$.ajax({
				type: "POST",
				url: weebotAJAXadmin.ajaxurl,
				data: {
					action: "weebotAJAXadmin",
					method: "init"
				},
				success: function(data){
					if(data!="") {
						setInterval(weebotAdmin.checkNewQuestions, 3000);
					}
				}
			});
		
			

			weebotAdmin.formSelectFiles();
			
			if($("#weebot-keywords").length>0) {
				$("#weebot-keywords").bind("keyup",function() {
					var words = $(this).val();
					var word_count = words.split(" ");
					$("#weebot-min-hit").val(word_count.length).attr("max",word_count.length);
					$("#weebot-min").val(word_count.length).attr("min",word_count.length);
					$("#weebot-max").val(word_count.length+2).attr("min",word_count.length);
				});
				$("#weebot-min-hit").bind("change",function() {
					$("#weebot-min").val($(this).val()).attr("min",$(this).val());
					$("#weebot-max").val(($(this).val()*1)+2).attr("min",($(this).val()*1));
				});
				$("#weebot-min").bind("change",function() {
					$("#weebot-max").val(($(this).val()*1)+2).attr("min",($(this).val()*1));
				});
			}
			
			if($("#weebot-lookup-answers").length>0) {
				$("#weebot-lookup-answers").bind("keypress",function(e) {
					if(e.keyCode==13) {
						weebotAdmin.lookup("answers",$(this).data("id"));
						return false;
					}
				});
				$("#weebot-lookup-answers-submit").bind("click",function() {
					weebotAdmin.lookup("answers",$(this).data("id"));
				});
			}
			
			if($(".select2").length>0) {
				$(".weebot-form .select2").select2();
			}
		}
	
	}

})( jQuery );